module.exports = {
  parser: '@typescript-eslint/parser',
  parserOptions: {
    project: 'tsconfig.json',
    sourceType: 'module',
  },
  plugins: ['@typescript-eslint/eslint-plugin', 'jest', 'unicorn', 'import'],
  extends: [
    'plugin:@typescript-eslint/eslint-recommended',
    'plugin:@typescript-eslint/recommended',
    'prettier'
  ],
  root: true,
  env: {
    node: true,
    jest: true,
    es6: true
  },
  overrides: [{
    files: ["*.test.js"],
  }],
  rules: {
    '@typescript-eslint/interface-name-prefix': 'off',
    '@typescript-eslint/explicit-function-return-type': 'off',
    '@typescript-eslint/no-explicit-any': ['error'],
    '@typescript-eslint/no-useless-constructor': ['error'],
    '@typescript-eslint/no-unused-vars': ['error'],
    '@typescript-eslint/no-ter': 'off',
    'jest/no-disabled-tests': ['error'],
    'jest/no-focused-tests': ['error'],
    'jest/no-identical-title': ['error'],
    'jest/prefer-to-have-length': ['error'],
    'import/order': ['error'],
    'import/export': ['error'],
    'import/no-absolute-path': ['error'],
    'import/no-self-import': ['error'],
    'import/named': ['error'],
    'import/no-useless-path-segments': ['error'],
    'import/max-dependencies': ['warn', { 'max': 20 }],
    'unicorn/no-abusive-eslint-disable': ['error'],
    'max-len': ['error', { 'code': 170 }],
    'indent': ['error', 4, { 'SwitchCase': 1 }],
    'linebreak-style': ['error', 'unix'],
    'quotes': ['error', 'single'],
    'no-case-declarations': ['off'],
    'brace-style': ['error'],
    'no-multi-spaces': ['error'],
    'no-trailing-spaces': ['error'],
    'no-inline-comments': ['error'],
    'comma-dangle': ['error', 'always-multiline'],
    'no-console': ['error', { allow: ['warn', 'error']}],
    'no-useless-concat': ['error'],
    'no-dupe-class-members': ['error'],
    'key-spacing': ['error'],
    'no-iterator': ['error'],
    'prefer-template': ['error'],
    'prefer-const': ['error'],
    'keyword-spacing': ['error'],
    'space-before-blocks': ['error'],
    'padded-blocks': ['error', 'never'],
    'no-multiple-empty-lines': ['error', { 'max': 1 }],
    'space-in-parens': ['error', 'never'],
    'no-var': ['error'],
    'no-new-wrappers': ['error'],
    'object-shorthand': ['error'],
    'object-curly-spacing': ['error', 'always', { 'objectsInObjects': false, 'arraysInObjects': false }],
    'no-else-return': 'error',
    'quote-props': ['error', 'as-needed'],
    'eqeqeq': ['warn', 'always'],
    'arrow-spacing': ['warn'],
    'comma-spacing': ['warn'],
    'max-lines': ['warn', { 'max': 350, 'skipBlankLines': true, 'skipComments': true }],
    'max-lines-per-function': ['error', { 'max': 80, 'skipComments': true }],
    'max-nested-callbacks': ['error', 4],
    'max-depth': ['error', 3],
    'no-nested-ternary': ['error'],
    'no-duplicate-imports': ['error'],
    'jsx-quotes': ['error'],
    'no-unused-expressions': ['error', { 'allowShortCircuit': true, 'allowTernary': true }],
    'no-param-reassign': ['error'],
    'complexity': ['error', { 'max': 10 }],
    'max-params': ['warn', { 'max': 6 }],
    'semi': 2
  }
};